import GGI.ascii

#define GII_KEY(typ,val)	(((typ) << 8) | (val))
#define GII_KTYP(x)		((x) >> 8)
#define GII_KVAL(x)		((x) & 0xff)
#define GII_UNICODE(x)		((x) < 0xE000 || (x) >= 0xF900)

################
# Type

ktLatin1 = 0x00
ktSpec	 = 0xE0
ktFn	 = 0xE1
ktPad	 = 0xE2
ktMod	 = 0xE3
ktDead	 = 0xE4

################
# modifiers

kmShift	 = 0x00
kmCtrl	 = 0x01
kmAlt	 = 0x02
kmMeta	 = 0x03
kmSuper	 = 0x04
kmHyper	 = 0x05
kmAltGr	 = 0x06
kmCaps	 = 0x07
kmNum	 = 0x08
kmScroll = 0x09

kmMask	 = 0x0f
kmRight	 = 0x40	 # additive
kmLock	 = 0x80	 #  - " -   (only used for labels)

##########################################
# Bits in the "modifiers" field

modShift  = (1 << kmShift)
modCtrl	  = (1 << kmCtrl)
modAlt	  = (1 << kmAlt)
modMeta	  = (1 << kmMeta)
modSuper  = (1 << kmSuper)
modHyper  = (1 << kmHyper)
modAltGr  = (1 << kmAltGr)
modCaps	  = (1 << kmCaps)
modNum	  = (1 << kmNum)
modScroll = (1 << kmScroll)

##############################
# function keys

_cnt=-1
def _nxtFn():
    global _cnt
    _cnt = _cnt+1
    return ((ktFn << 8) | (_cnt))

kF0  = _nxtFn()
kF1  = _nxtFn()
kF2  = _nxtFn()
kF3  = _nxtFn()
kF4  = _nxtFn()
kF5  = _nxtFn()
kF6  = _nxtFn()
kF7  = _nxtFn()
kF8  = _nxtFn()
kF9  = _nxtFn()
kF10 = _nxtFn()
kF11 = _nxtFn()
kF12 = _nxtFn()
kF13 = _nxtFn()
kF14 = _nxtFn()
kF15 = _nxtFn()
kF16 = _nxtFn()
kF17 = _nxtFn()
kF18 = _nxtFn()
kF19 = _nxtFn()
kF20 = _nxtFn()
kF21 = _nxtFn()
kF22 = _nxtFn()
kF23 = _nxtFn()
kF24 = _nxtFn()
kF25 = _nxtFn()
kF26 = _nxtFn()
kF27 = _nxtFn()
kF28 = _nxtFn()
kF29 = _nxtFn()
kF30 = _nxtFn()
kF31 = _nxtFn()
kF32 = _nxtFn()
kF33 = _nxtFn()
kF34 = _nxtFn()
kF35 = _nxtFn()
kF36 = _nxtFn()
kF37 = _nxtFn()
kF38 = _nxtFn()
kF39 = _nxtFn()
kF40 = _nxtFn()
kF41 = _nxtFn()
kF42 = _nxtFn()
kF43 = _nxtFn()
kF44 = _nxtFn()
kF45 = _nxtFn()
kF46 = _nxtFn()
kF47 = _nxtFn()
kF48 = _nxtFn()
kF49 = _nxtFn()
kF50 = _nxtFn()
kF51 = _nxtFn()
kF52 = _nxtFn()
kF53 = _nxtFn()
kF54 = _nxtFn()
kF55 = _nxtFn()
kF56 = _nxtFn()
kF57 = _nxtFn()
kF58 = _nxtFn()
kF59 = _nxtFn()
kF60 = _nxtFn()
kF61 = _nxtFn()
kF62 = _nxtFn()
kF63 = _nxtFn()
kF64 = _nxtFn()

#########################
# special keys

def _mkSpec(n):
    return ((ktSpec << 8) | n)


kVoid	        = _mkSpec(0)

kEnter		= GGI.ascii.u_Return
kDelete		= GGI.ascii.u_Delete

kBreak		= _mkSpec(5)

kScrollForw	= _mkSpec(10)
kScrollBack	= _mkSpec(11)

kBoot	        = _mkSpec(12)
kCompose	= _mkSpec(14)
kSAK		= _mkSpec(15)

kUndo		= _mkSpec(23)
kRedo		= _mkSpec(24)
kMenu		= _mkSpec(25)
kCancel		= _mkSpec(26)
kPrintScreen	= _mkSpec(27)
kExecute	= _mkSpec(28)
kFind		= _mkSpec(30)
kBegin		= _mkSpec(31)
kClear		= _mkSpec(32)
kInsert		= _mkSpec(34)
kSelect		= _mkSpec(35)
kMacro	 	= _mkSpec(38)
kHelp		= _mkSpec(39)
kDo	        = _mkSpec(40)
kPause	 	= _mkSpec(41)
kStop		= kPause
kSysRq		= _mkSpec(42)
kModeSwitch	= _mkSpec(43)

kUp		= _mkSpec(50)
kDown		= _mkSpec(51)
kLeft		= _mkSpec(52)
kRight		= _mkSpec(53)
kPrior		= _mkSpec(54)
kPageUp		= kPrior
kNext		= _mkSpec(55)
kPageDown	= kNext
kHome		= _mkSpec(56)
kEnd		= _mkSpec(57)


####################################
# keys on the numeric keypad
def _mkPad(n):
    return ((ktPad << 8) | n)

kP0      = _mkPad(ord('0'))
kP1	 = _mkPad(ord('1'))
kP2	 = _mkPad(ord('2'))
kP3	 = _mkPad(ord('3'))
kP4	 = _mkPad(ord('4'))
kP5	 = _mkPad(ord('5'))
kP6	 = _mkPad(ord('6'))
kP7	 = _mkPad(ord('7'))
kP8	 = _mkPad(ord('8'))
kP9	 = _mkPad(ord('9'))
kPA	 = _mkPad(ord('A'))
kPB	 = _mkPad(ord('B'))
kPC	 = _mkPad(ord('C'))
kPD	 = _mkPad(ord('D'))
kPE	 = _mkPad(ord('E'))
kPF	 = _mkPad(ord('F'))

kPPlus	      = _mkPad(ord('+'))
kPMinus	      = _mkPad(ord('-'))
kPSlash	      = _mkPad(ord('/'))
kPAsterisk    = _mkPad(ord('*'))
kPStar	      = kPAsterisk
kPEqual	      = _mkPad(ord('='))
kPSeparator   = _mkPad(ord(','))
kPDecimal     = _mkPad(ord('.'))
kPParenLeft   = _mkPad(ord('('))
kPParenRight  = _mkPad(ord(')'))
kPSpace	      = _mkPad(ord(' '))
kPEnter	      = _mkPad(ord('\r'))
kPTab	      = _mkPad(ord('\t'))

kPPlusMinus   = _mkPad(0x80)
kPBegin	      = _mkPad(0x81)

kPF1	      = _mkPad(0x91)
kPF2	      = _mkPad(0x92)
kPF3	      = _mkPad(0x93)
kPF4	      = _mkPad(0x94)
kPF5	      = _mkPad(0x95)
kPF6	      = _mkPad(0x96)
kPF7	      = _mkPad(0x97)
kPF8	      = _mkPad(0x98)
kPF9	      = _mkPad(0x99)

##################################
# modifier keys
def _mkMod(n):
    return ((ktMod << 8) | n)

kShift		= _mkMod(kmShift)
kCtrl		= _mkMod(kmCtrl)
kAlt		= _mkMod(kmAlt)
kMeta		= _mkMod(kmMeta)
kSuper		= _mkMod(kmSuper)
kHyper		= _mkMod(kmHyper)
kAltGr		= _mkMod(kmAltGr)
kCaps		= _mkMod(kmCaps)
kNum		= _mkMod(kmNum)
kScroll		= _mkMod(kmScroll)

###################################
# modifier _labels_

kShiftL		= kShift  | 0
kShiftR		= kShift  | kmRight
kCtrlL		= kCtrl   | 0
kCtrlR		= kCtrl   | kmRight
kAltL		= kAlt    | 0
kAltR		= kAlt    | kmRight
kMetaL		= kMeta   | 0
kMetaR		= kMeta   | kmRight
kSuperL		= kSuper  | 0
kSuperR		= kSuper  | kmRight
kHyperL		= kHyper  | 0
kHyperR		= kHyper  | kmRight

kShiftLock	= kShift  | kmLock
kCtrlLock	= kCtrl   | kmLock
kAltLock	= kAlt    | kmLock
kMetaLock	= kMeta   | kmLock
kSuperLock	= kSuper  | kmLock
kHyperLock	= kHyper  | kmLock
kAltGrLock	= kAltGr  | kmLock
kCapsLock	= kCaps   | kmLock
kNumLock	= kNum    | kmLock
kScrollLock	= kScroll | kmLock

#######################################
# miscellaneous

kNil      =  	0xffff	# used to indicate "not mapped yet"
buttonNil =	0xff	# used for pseudo keys (composed ones)

########################################
# Dead keys
def _mkDead(n):
    return ((ktDead << 8) | n)

kDeadRing		= _mkDead(0x00)
kDeadCaron		= _mkDead(0x01)
kDeadOgonek		= _mkDead(0x02)
kDeadIota		= _mkDead(0x03)
kDeadDoubleAcute	= _mkDead(0x04)
kDeadBreve		= _mkDead(0x05)
kDeadAboveDot		= _mkDead(0x06)
kDeadBelowDot		= _mkDead(0x07)
kDeadVoicedSound	= _mkDead(0x08)
kDeadSemiVoicedSound	= _mkDead(0x09)

kDeadAcute		= _mkDead(GGI.ascii.u_Acute)
kDeadCedilla		= _mkDead(GGI.ascii.u_Cedilla)
kDeadCircumflex		= _mkDead(GGI.ascii.u_Circumflex)
kDeadDiaeresis		= _mkDead(GGI.ascii.u_Diaeresis)
kDeadGrave		= _mkDead(GGI.ascii.u_Grave)
kDeadTilde		= _mkDead(GGI.ascii.u_Tilde)
kDeadMacron		= _mkDead(GGI.ascii.u_Macron)

#endif /* _GII_KEYBOARD_H */
